--© Turf War | NaSH | Argentina | 25/01/2013 | Twitter: @mNap_ | USGN: 10028

imap = {}

function recognizeMap()

	local ent_list=entitylist(91)
	
	local start_x = 0
	local end_x = 0
	local start_y = 0
	local end_y = 0
	
	for _,e in pairs(ent_list) do
		if entity(e.x, e.y, "name") == "start_x" then
			start_x = e.x
		elseif entity(e.x, e.y, "name") == "end_x" then
			end_x = e.x
		elseif entity(e.x, e.y, "name") == "start_y" then
			start_y = e.y
		elseif entity(e.x, e.y, "name") == "end_y" then
			end_y = e.y
		end
	end
	
	point = {
			sx = start_x, 
			ex = end_x, 
			sy = start_y, 
			ey = end_y
		}
		
	return point
end

function drawDivider()
	local tx = imap["middle_point"]
	local mid = imap["point"]["sx"] + 1 + imap["point"]["middle_x"]
	if tx == mid then --Neutral
		local tile_y = imap["point"]["sy"]
		for i = 1, imap["cage_size_y"]+1 do
			local ty = tile_y + i
			if tile(tx, ty, "walkable") then
				parse("spawnobject 6 "..tx.." "..ty)
			end
		end
	else
		local tile_y = imap["point"]["sy"]
		for i = 1, imap["cage_size_y"]+1 do
			local ty = tile_y + i
			local tx_ct = tx + 1
			if tile(tx, ty, "walkable") then
				parse("spawnobject 6 "..tx.." "..ty.." 0 0 1")
			end
			if tile(tx_ct, ty, "walkable") then
				parse("spawnobject 6 "..tx_ct.." "..ty.." 0 0 2")
			end
		end
	end
end

function updateDivider(m)
--[[
	local mid = imap["point"]["sx"] + 1 + imap["point"]["middle_x"]
	if mid == imap["middle_point"] then
		for i = 1, imap["cage_size_y"] do
			parse("killobject "..i)
		end
	else
		for i = 1, imap["cage_size_y"] * 2 do
			parse("killobject "..i)
		end
	end
	]]
	local objectlist = object(0,"table")
	for _,i in pairs(objectlist) do
		if object(i, "type") == 6 then
			parse("killobject "..i)
		end
	end
	imap["middle_point"] = imap["middle_point"] + m
	drawDivider()
	
	if imap["middle_point"] - imap["point"]["sx"]  == imap["cage_size_x"] + 1 then
		parse('trigger twin')
	elseif imap["middle_point"] - imap["point"]["sx"] == 0 then
		parse('trigger ctwin')
	end
end

function buildMap()
	imap = {}
	imap["point"] = recognizeMap()
	imap["cage_size_x"] = imap["point"]["ex"] - imap["point"]["sx"] - 2
	imap["cage_size_y"] = imap["point"]["ey"] - imap["point"]["sy"] - 2
	imap["point"]["middle_x"] = math.ceil( imap["cage_size_x"] / 2 )
	imap["middle_point"] = imap["point"]["sx"] + 1 + imap["point"]["middle_x"]

	drawDivider()
end

function setConfig()
	buildMap()
	parse("mp_damagefactor 100")
	parse("sv_gm 2")
	parse('mp_wpndmg "HE" 0')
	parse("mp_radar 0")
	parse("mp_hud 8")
end

function setGame()
	imap["middle_point"] = imap["point"]["sx"] + 1 + imap["point"]["middle_x"]
	drawDivider()
end

function onHit(id, source)
	local iplayer = player(0, "table")
	for i = 1, #iplayer do
		parse("shake "..i.." 13")
	end
	
	local vctm_team = player(id, "team")
	local hudtxt_color = "©000162232"
	move_divider = -1
	if vctm_team == 2 then
		move_divider = 1
		hudtxt_color = "©252063063" --color bug, probly due to languages, won't be applied
	end
	local ah = " (autohit)"
	local src_name = ""
	if source == 0 then
		parse("killplayer "..id)
	else
		src_name = player(source, "name").." to "
		ah = ""
	end
	vctm_name = player(id, "name")
	parse('hudtxt 1 "Last hit: '..src_name..vctm_name..ah..'" 250 425 0')
	updateDivider(move_divider)
	return 1
end

function onMapChange()
	setConfig()
end

function onStartRound()
	setGame()
	iplayer = player(0,"table")
end

addhook("hit","onHit")
addhook("mapchange","onMapChange")
addhook("startround","onStartRound")

setConfig()